Index: boot/Makefile
===================================================================
--- boot/Makefile	(revision e88eb48e75ad044807a59279a35841cbebbc9611)
+++ boot/Makefile	(revision df8eababb31187582db57d47cd83f7ecfb4f1ee9)
@@ -39,6 +39,6 @@
 build_dist: clean_dist
 	mkdir -p "$(DIST_PATH)/app/"
-	mkdir -p "$(DIST_PATH)/cfg/net/"
-	mkdir -p "$(DIST_PATH)/data/cfg/"
+	mkdir -p "$(DIST_PATH)/cfg/"
+	mkdir -p "$(DIST_PATH)/data/"
 	mkdir -p "$(DIST_PATH)/lib/"
 	mkdir -p "$(DIST_PATH)/loc/"
@@ -48,4 +48,5 @@
 	mkdir -p "$(DIST_PATH)/tmp/"
 	mkdir -p "$(DIST_PATH)/vol/"
+	mkdir -p "$(DIST_PATH)/w/"
 	for file in $(RD_SRVS) ; do \
 		cp "$$file" "$(DIST_PATH)/srv/" ; \
@@ -135,4 +136,6 @@
 	rm -f $(INITRD).img $(COMPS).s $(COMPS).h $(COMPS)_desc.c $(COMPONENTS_DEFLATE) $(COMPS).o $(COMPS)_desc.o $(COMPS).zip $(LINK)
 	find $(USPACE_PATH)/dist -mindepth 1 -maxdepth 1 -type f -exec rm \{\} \;
+	rm -f $(USPACE_PATH)/dist/app/*
+	rm -f $(USPACE_PATH)/dist/cfg/*
 	rm -f $(USPACE_PATH)/dist/srv/*
 	rm -rf $(USPACE_PATH)/dist/drv/*
@@ -142,2 +145,3 @@
 	rm -f $(USPACE_PATH)/dist/test/*
 	rm -f $(USPACE_PATH)/dist/cfg/net/*
+	rm -f $(USPACE_PATH)/dist/w/*
Index: tools/mkext2.py
===================================================================
--- tools/mkext2.py	(revision e88eb48e75ad044807a59279a35841cbebbc9611)
+++ tools/mkext2.py	(revision df8eababb31187582db57d47cd83f7ecfb4f1ee9)
@@ -310,5 +310,5 @@
 		sb.features_read_only = 0
 		sb.uuid = self.uuid.bytes_le
-		sb.volume_name = 'HelenOS rdimage\0'
+		sb.volume_name = 'HelenOS-rd\0\0\0\0\0\0'
 		self.outf.write(bytes(sb.pack()))
 
Index: uspace/app/sysinst/Makefile
===================================================================
--- uspace/app/sysinst/Makefile	(revision e88eb48e75ad044807a59279a35841cbebbc9611)
+++ uspace/app/sysinst/Makefile	(revision df8eababb31187582db57d47cd83f7ecfb4f1ee9)
@@ -28,5 +28,5 @@
 
 USPACE_PREFIX = ../..
-LIBS = block fdisk
+LIBS = block fdisk sif
 
 BINARY = sysinst
@@ -34,5 +34,7 @@
 SOURCES = \
 	futil.c \
-	sysinst.c
+	rdimg.c \
+	sysinst.c \
+	volume.c
 
 include $(USPACE_PREFIX)/Makefile.common
Index: uspace/app/sysinst/rdimg.c
===================================================================
--- uspace/app/sysinst/rdimg.c	(revision df8eababb31187582db57d47cd83f7ecfb4f1ee9)
+++ uspace/app/sysinst/rdimg.c	(revision df8eababb31187582db57d47cd83f7ecfb4f1ee9)
@@ -0,0 +1,219 @@
+/*
+ * Copyright (c) 2018 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup sysinst
+ * @{
+ */
+/** @file RAM disk image manipulation
+ */
+
+#include <errno.h>
+#include <stdio.h>
+#include <stdlib.h>
+#include <str.h>
+#include <task.h>
+#include <vfs/vfs.h>
+#include <vol.h>
+
+#include "rdimg.h"
+
+#define FILE_BD "/srv/file_bd"
+#define RD_SVC "bd/iird"
+#define RD_LABEL "HelenOS-rd"
+
+/** Find volume by volume label. */
+static errno_t rd_img_part_by_label(vol_t *vol, const char *label,
+    service_id_t *rid)
+{
+	vol_part_info_t vinfo;
+	service_id_t *part_ids = NULL;
+	size_t nparts;
+	size_t i;
+	errno_t rc;
+
+	rc = vol_get_parts(vol, &part_ids, &nparts);
+	if (rc != EOK) {
+		printf("Error getting list of volumes.\n");
+		goto out;
+	}
+
+	for (i = 0; i < nparts; i++) {
+		rc = vol_part_info(vol, part_ids[i], &vinfo);
+		if (rc != EOK) {
+			printf("Error getting volume information.\n");
+			rc = EIO;
+			goto out;
+		}
+
+		if (str_cmp(vinfo.label, label) == 0) {
+			*rid = part_ids[i];
+			rc = EOK;
+			goto out;
+		}
+	}
+
+	rc = ENOENT;
+out:
+	free(part_ids);
+	return rc;
+}
+
+/** Open RAM disk image.
+ *
+ * @param imgpath Image path
+ * @param rpath Place to store pointer to newly allocated string, the path to
+ *              the mounted RAM disk.
+ * @param rimg Place to store pointer to newly allocated object.
+ *
+ * @return EOK on success or an error code
+ */
+errno_t rd_img_open(const char *imgpath, char **rpath, rd_img_t **rimg)
+{
+	rd_img_t *img = NULL;
+	char *rdpath = NULL;
+	errno_t rc;
+	task_id_t id;
+	task_wait_t wait;
+	task_exit_t texit;
+	vfs_stat_t stat;
+	int retval;
+	int cnt;
+
+	printf("rd_img_open: begin\n");
+	rdpath = str_dup("/vol/" RD_LABEL);
+	if (rdpath == NULL) {
+		rc = ENOMEM;
+		goto error;
+	}
+
+	img = calloc(1, sizeof(rd_img_t));
+	if (img == NULL) {
+		rc = ENOMEM;
+		goto error;
+	}
+
+	printf("rd_img_open: spawn file_bd\n");
+	rc = task_spawnl(&id, &wait, FILE_BD, FILE_BD, imgpath, RD_SVC, NULL);
+	if (rc != EOK) {
+		rc = EIO;
+		goto error;
+	}
+
+	printf("rd_img_open: wait for file_bd\n");
+	rc = task_wait(&wait, &texit, &retval);
+	if (rc != EOK || texit != TASK_EXIT_NORMAL) {
+		rc = EIO;
+		goto error;
+	}
+
+	/* Wait for the RAM disk to become available */
+	printf("rd_img_open: wait for RAM disk to be mounted\n");
+	cnt = 10;
+	while (cnt > 0) {
+		rc = vfs_stat_path(rdpath, &stat);
+		if (rc == EOK)
+			break;
+
+		fibril_sleep(1);
+		--cnt;
+	}
+
+	if (cnt == 0) {
+		printf("rd_img_open: ran out of time\n");
+		rc = EIO;
+		goto error;
+	}
+
+	img->filebd_tid = id;
+	*rimg = img;
+	*rpath = rdpath;
+	printf("rd_img_open: success\n");
+	return EOK;
+error:
+	if (rdpath != NULL)
+		free(rdpath);
+	if (img != NULL)
+		free(img);
+	return rc;
+}
+
+/** Close RAM disk image.
+ *
+ */
+errno_t rd_img_close(rd_img_t *img)
+{
+	errno_t rc;
+	service_id_t rd_svcid;
+	vol_t *vol = NULL;
+
+	printf("rd_img_close: begin\n");
+
+	rc = vol_create(&vol);
+	if (rc != EOK) {
+		printf("Error opening volume management service.\n");
+		rc = EIO;
+		goto error;
+	}
+
+	printf("rd_img_close: Find RAM disk volume.\n");
+	rc = rd_img_part_by_label(vol, RD_LABEL, &rd_svcid);
+	if (rc != EOK) {
+		printf("Error getting RAM disk service ID.\n");
+		rc = EIO;
+		goto error;
+	}
+
+	printf("rd_img_close: eject RAM disk volume\n");
+	rc = vol_part_eject(vol, rd_svcid);
+	if (rc != EOK) {
+		printf("Error ejecting RAM disk volume.\n");
+		rc = EIO;
+		goto error;
+	}
+
+	vol_destroy(vol);
+
+	rc = task_kill(img->filebd_tid);
+	if (rc != EOK) {
+		printf("Error killing file_bd.\n");
+		rc = EIO;
+		goto error;
+	}
+
+	free(img);
+	printf("rd_img_close: success\n");
+	return EOK;
+error:
+	free(img);
+	if (vol != NULL)
+		vol_destroy(vol);
+	return rc;
+}
+
+/** @}
+ */
Index: uspace/app/sysinst/rdimg.h
===================================================================
--- uspace/app/sysinst/rdimg.h	(revision df8eababb31187582db57d47cd83f7ecfb4f1ee9)
+++ uspace/app/sysinst/rdimg.h	(revision df8eababb31187582db57d47cd83f7ecfb4f1ee9)
@@ -0,0 +1,55 @@
+/*
+ * Copyright (c) 2018 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup sysinst
+ * @{
+ */
+/**
+ * @file
+ * @brief
+ */
+
+#ifndef RDIMG_H
+#define RDIMG_H
+
+#include <errno.h>
+#include <task.h>
+
+/** Open RAM disk image */
+typedef struct {
+	/** Task ID of file_bd providing the RAM disk */
+	task_id_t filebd_tid;
+} rd_img_t;
+
+extern errno_t rd_img_open(const char *, char **, rd_img_t **);
+extern errno_t rd_img_close(rd_img_t *);
+
+#endif
+
+/** @}
+ */
Index: uspace/app/sysinst/sysinst.c
===================================================================
--- uspace/app/sysinst/sysinst.c	(revision e88eb48e75ad044807a59279a35841cbebbc9611)
+++ uspace/app/sysinst/sysinst.c	(revision df8eababb31187582db57d47cd83f7ecfb4f1ee9)
@@ -51,4 +51,6 @@
 #include "futil.h"
 #include "grub.h"
+#include "rdimg.h"
+#include "volume.h"
 
 /** Device to install to
@@ -64,4 +66,6 @@
 /** Volume label for the new file system */
 #define INST_VOL_LABEL "HelenOS"
+/** Mount point of system partition when running installed system */
+#define INST_VOL_MP "/w"
 
 #define MOUNT_POINT "/inst"
@@ -173,4 +177,88 @@
 	printf("sysinst_copy_boot_files(): OK\n");
 	return EOK;
+}
+
+/** Set up configuration in the initial RAM disk.
+ *
+ * @return EOK on success or an error code
+ */
+static errno_t sysinst_customize_initrd(void)
+{
+	errno_t rc;
+	rd_img_t *rd = NULL;
+	char *rdpath = NULL;
+	char *path = NULL;
+	vol_volumes_t *volumes = NULL;
+	vol_volume_t *volume = NULL;
+	int rv;
+
+	rc = rd_img_open(MOUNT_POINT "/boot/initrd.img", &rdpath, &rd);
+	if (rc != EOK) {
+		printf("Error opening initial RAM disk image.\n");
+		goto error;
+	}
+
+	rv = asprintf(&path, "%s%s", rdpath, "/cfg/volsrv.sif");
+	if (rv < 0) {
+		rc = ENOMEM;
+		goto error;
+	}
+
+	printf("Configuring volume server.\n");
+	rc = vol_volumes_create(path, &volumes);
+	if (rc != EOK) {
+		printf("Error creating volume server configuration.\n");
+		rc = EIO;
+		goto error;
+	}
+
+	printf("Configuring volume server: look up volume\n");
+	rc = vol_volume_lookup_ref(volumes, INST_VOL_LABEL, &volume);
+	if (rc != EOK) {
+		printf("Error creating volume server configuration.\n");
+		rc = EIO;
+		goto error;
+	}
+
+	printf("Configuring volume server: set mount point\n");
+	rc = vol_volume_set_mountp(volume, INST_VOL_MP);
+	if (rc != EOK) {
+		printf("Error creating system partition configuration.\n");
+		rc = EIO;
+		goto error;
+	}
+
+	printf("Configuring volume server: delete reference\n");
+	vol_volume_del_ref(volume);
+	volume = NULL;
+	printf("Configuring volume server: destroy volumes object\n");
+	vol_volumes_destroy(volumes);
+	volumes = NULL;
+
+	rc = rd_img_close(rd);
+	if (rc != EOK) {
+		printf("Error closing initial RAM disk image.\n");
+		rc = EIO;
+		goto error;
+	}
+
+	free(rdpath);
+	rdpath = NULL;
+	free(path);
+	path = NULL;
+
+	return EOK;
+error:
+	if (volume != NULL)
+		vol_volume_del_ref(volume);
+	if (volumes != NULL)
+		vol_volumes_destroy(volumes);
+	if (rd != NULL)
+		(void) rd_img_close(rd);
+	if (path != NULL)
+		free(path);
+	if (rdpath != NULL)
+		free(rdpath);
+	return rc;
 }
 
@@ -332,4 +420,9 @@
 		return rc;
 
+	printf("Boot files done. Configuring the system.\n");
+	rc = sysinst_customize_initrd();
+	if (rc != EOK)
+		return rc;
+
 	printf("Boot files done. Installing boot blocks.\n");
 	rc = sysinst_copy_boot_blocks(dev);
Index: uspace/app/sysinst/types/volume.h
===================================================================
--- uspace/app/sysinst/types/volume.h	(revision df8eababb31187582db57d47cd83f7ecfb4f1ee9)
+++ uspace/app/sysinst/types/volume.h	(revision df8eababb31187582db57d47cd83f7ecfb4f1ee9)
@@ -0,0 +1,1 @@
+../../../srv/volsrv/types/volume.h
Index: uspace/app/sysinst/volume.c
===================================================================
--- uspace/app/sysinst/volume.c	(revision df8eababb31187582db57d47cd83f7ecfb4f1ee9)
+++ uspace/app/sysinst/volume.c	(revision df8eababb31187582db57d47cd83f7ecfb4f1ee9)
@@ -0,0 +1,1 @@
+../../srv/volsrv/volume.c
Index: uspace/app/sysinst/volume.h
===================================================================
--- uspace/app/sysinst/volume.h	(revision df8eababb31187582db57d47cd83f7ecfb4f1ee9)
+++ uspace/app/sysinst/volume.h	(revision df8eababb31187582db57d47cd83f7ecfb4f1ee9)
@@ -0,0 +1,1 @@
+../../srv/volsrv/volume.h
Index: uspace/srv/volsrv/volsrv.c
===================================================================
--- uspace/srv/volsrv/volsrv.c	(revision e88eb48e75ad044807a59279a35841cbebbc9611)
+++ uspace/srv/volsrv/volsrv.c	(revision df8eababb31187582db57d47cd83f7ecfb4f1ee9)
@@ -53,5 +53,5 @@
 #define NAME  "volsrv"
 
-const char *vol_cfg_file = "/data/cfg/volsrv.sif";
+const char *vol_cfg_file = "/cfg/volsrv.sif";
 
 static void vol_client_conn(ipc_call_t *, void *);
Index: uspace/srv/volsrv/volume.c
===================================================================
--- uspace/srv/volsrv/volume.c	(revision e88eb48e75ad044807a59279a35841cbebbc9611)
+++ uspace/srv/volsrv/volume.c	(revision df8eababb31187582db57d47cd83f7ecfb4f1ee9)
@@ -205,4 +205,5 @@
 	}
 
+	(void) sif_close(volumes->repo);
 	free(volumes);
 }
